//ProgEx40d
/*
  ProgEx40d  -- Form3: Volume Of Your Box.  Getting Box Data To The Output Screen
                And Displaying It.

  Have you given some thought as to how we're going to get the Box data calculations
  to here?  And don't forget!  No globals!  If we had a handle to the main program
  window we would be able to get the data out of the text boxes the way we did in
  btnCalculate_OnClick().  But we don't have any such here in the Output Screen Window.

  Remember something I said about the last parameter of the CreateWindow() call back
  in ProgEx40 - the 1st program in this series?  Here it is again to refresh your
  memory...

  The last parameter - the 11th, we just assigned NULL.  We didn't use it.  However its
  typed like so...

  LPVOID lpParam        // pointer to window-creation data

  This is a pointer parameter and it can be a pointer to anything whatsoever you have a
  mind to pass to the WM_CREATE handler of your Window Procedure.  Its another global
  killer is what it is.  I'm not going to say anymore about it here because we're not
  using it in this first version of this app.  Just tuck away for future reference that
  its very important (and we'll be using it soon).

                                     --End Quote--

  Look for a minute back in btnDisplay_OnClick() of the last example.  Even better, here
  it is...

  void btnDisplay_OnClick(lpWndEventArgs Wea)
  {
   ProgramData ProDta;
   char szBuffer[64];
   HINSTANCE hIns;
   HWND hWnd;

   GetWindowText(GetDlgItem(Wea->hWnd,IDC_EDIT_LENGTH),szBuffer,16), ProDta.dblLength=atof(szBuffer);
   GetWindowText(GetDlgItem(Wea->hWnd,IDC_EDIT_WIDTH),szBuffer,16),  ProDta.dblWidth=atof(szBuffer);
   GetWindowText(GetDlgItem(Wea->hWnd,IDC_EDIT_HEIGHT),szBuffer,16), ProDta.dblHeight=atof(szBuffer);
   GetWindowText(GetDlgItem(Wea->hWnd,IDC_COMBO_TYPE),ProDta.szBoxType,16);
   ProDta.dblVolume = ProDta.dblLength * ProDta.dblWidth * ProDta.dblHeight;
   hIns=GetModuleHandle(0);
   hWnd=CreateWindow("Output","Output Screen",WS_OVERLAPPEDWINDOW,650,300,350,200,0,0,hIns,NULL);
   ShowWindow(hWnd,SW_SHOWNORMAL);
  }

  Note that we have a struct of ProgramData type declared and its instance ProDta is
  holding all the information we would like to display in the Output Screen.  Also note
  that there is a big fat useless NULL sitting in that last Window Creation Data position
  discussed above.  If that big fat useless NULL is getting a free ride over to
  fnOutputProc_OnCreate() I see no reason we shouldn't give the address of that
  ProgramData instance its place instead.  The NULL is doing us no good and that
  ProgramData instance has every last bit of information we need.  Its a no brainer.
  So all we need to do is attach an ampersand '&' operator in front of the ProDta instance
  and its there!

  Something else I've mentioned before but I'll elaborate just a bit.  When that CreateWindow()
  call executes obviously code inside Windows will be running and somewhere in that process
  a WM_CREATE message will show up in the Window Procedure of the class passed as the
  szClassName parameter of the CreateWindow() call.  The CreateWindow() call itself will
  not return until the WM_CREATE message has been completely processed.  Momentarily we
  will be extracting that ProgramData pointer from the CREATESTRUCT we'll have access to
  in fnOutputProc_OnCreate(), but during the time our code is running in our OnCreate()
  handler, we'll also be able to pass any data we would like back through the CreateWindow()
  call to the point of that call in btnDisplay_OnClick().  Because, don't forget, when we
  do finally get access to the ProgramData ProDta object, its actually allocated on the stack
  back in btnDisplay_OnClick().  Its not some kind of copy being passed to us.  To give a
  more concrete example, had we not calculated the volume of the box back in btnDisplay_OnClick,
  and had only passed the length, width, and height, the volume could have been calculated
  and stored through the pointer received in fnOutputProc_OnCreate, and when the CreateWindow()
  call would have returned, ProDta.dblVolume would have been calculated.  Its the same variable
  we're working with in both procedures simultaneously.

  Moving on to fnOutputProc_OnCreate, all we need to do to get our box data is dereference the
  lParam pointer passed to us, cast it to a ProgramData*, and retrieve our info.  Here is
  fnOutputProc_OnCreate...

  long fnOutputProc_OnCreate(lpWndEventArgs Wea)
  {
   CREATESTRUCT *pCreateStruct;
   ProgramData* pProgramData;
   ProgramData* pMain;

   pCreateStruct=(CREATESTRUCT*)Wea->lParam;
   pMain=(ProgramData*)pCreateStruct->lpCreateParams;
   pProgramData=(ProgramData*)GlobalAlloc(GPTR,sizeof(ProgramData));
   if(pProgramData)
   {
      SetWindowLong(Wea->hWnd,0,(long)pProgramData);
      pProgramData->dblLength=pMain->dblLength;
      pProgramData->dblWidth=pMain->dblWidth;
      pProgramData->dblHeight=pMain->dblHeight;
      pProgramData->dblVolume=pMain->dblVolume;
      strcpy(pProgramData->szBoxType,pMain->szBoxType);
   }
   else           //If we can't allocate the memory there isn't much use
      return -1;  //continuing so -1 causes CreateWindow to fail and there
                  //won't be any output screen.
   return 0;
  }

  However, here is where one must think things over seriously!  What we've got is a
  program that calculates something - in our case the volumes of silly boxes, but
  don't forget that there is a Display button that allows the user to display the
  calculations for many boxes one after the other; certainly more than one; perhaps
  as many as could fill the computer screen and then some yet minimized!  The user
  might simply want to compare the dimensions and volumes of a number of boxes at
  once.  Related to this issue is that here in the fnOutputProc_OnCreate() handler
  we're in no position to even display this data even though we've now got it
  because windows are not yet visible during their WM_CREATE message.  Windows don't
  in fact become visible until several messages later among them WM_SIZE and WM_PAINT.
  And long before the window becomes visible our fnOutputProc_OnCreate() will return;
  the CreateWindow() call back in btnDisplay_OnClick() will return; and that procedure
  itself will exit and that ProgramData object on the stack will be gone!  Some apples
  huh!

  All this points up to the fact that in fnOutputProc_OnCreate() when we momentarily -
  for perhaps 1/1000 th second, obtain that pointer to a ProgramData object, we had
  better store our own copy of it as fast as we can.  And we're going to have to store
  it in such a way that our window will have access to it when it receives a WM_PAINT
  message from Windows.  Remember what we did in our various versions of Form2 where
  we stored then displayed mouse movements, window resizing, typed characters, etc?
  We received this information from Windows in one message, stored it for awhile, then
  TextOut'ed it during the WM_PAINT we forced.  We need to do the same thing here
  except that we don't need to do any InvalidateRect() to force repaints.  We'll get a
  WM_PAINT when the ShowWindow() call right beneath the CreateWindow() in
  btnDisplay_OnClick() executes.

  The only other issue is that we're going to have to allocate memory dynamically with
  some memory allocation function or other to store the data because all we have at the
  point of reception of the CREATSTRUCT data is a pointer that will very soon be
  invalid.  Look up in the code just posted and you can see what I've done.  I allocated
  two ProgramData pointers in the procedure; one for the incoming CREATSTRUCT data -
  pMain; and another to reference my memory allocation - pProgramData.  Then I copy the
  data from Form3 into my allocated memory and store the pointer at offset zero in the
  four bytes of cbWndExtra memory I requested of Windows when we registered the "Output"
  Window Class.

  Its truely amazing how complicated even a program to calculate the volume of a box
  can become isn't it?  Well, I truely believe the worst is over because at this point
  all that's left to do is retrieve the data stored at our pointer in the WM_PAINT
  handler and TextOut() some data; the only real wrinkle being that with default
  non-fixed width fonts our numbers don't line up!  So take a look at
  fnOutputProc_OnPaint() and you'll see I had to use a truely ugly Api function named
  CreateFont() to create a suitable fixed width font for text drawing purposes.  If
  you are new to this its also rather ugly because once you create any GDI ( Graphics
  Device Interface ) object you need to first select it into the device context, save
  what comes out of the device context when your new stuff goes in, then when you're done
  with the whole thing select the old value back in the device context, then delete the
  GDI object you created.  I guess this is why we lose so many good folks to MFC, .NET,
  etc.  Anyway, you can see the TextOut() calls that produce the output.

  Finally, all that's left to do is write a WM_CLOSE handler to destroy the window when
  the user [x]'s out and release the memory allocation done in the WM_CREATE handler.
  But will the user [X] out???  What if he/she/it makes five or six Box output Windows
  and doesn't close any of them and just [x]'s out of the whole application of Form3
  leaving the Output Windows hanging?  If you try it you'll see that when you close
  the main Form any remaining Output Windows go with it.  But will WM_CLOSE calls come
  to do the memory cleanup?  I don't believe so.  Perhaps WM_DESTROY messages will come
  through but I don't believe WM_CLOSE will. To take care of that scenerio back in
  Form3's WM_CLOSE I run a do loop with a FindWindowEx() call in it that loops searching
  the system for any living "Output" class windows and kills them.

  With CodeBlocks we're up to 10,240 bytes!
*/

//Main.cpp
#include <windows.h>
#include <stdio.h>
#include "ProgEx40d.h"
#include "Output.h"
EVENTHANDLER  MainHandler[3];
EVENTHANDLER  OutputHandler[3];


long fnWndProc_OnCreate(lpWndEventArgs Wea)
{
 char* szBuffer[]={"Ordinary Box","Box Of Junk","Beer Crate","Wine Box","Candy Box"};
 DWORD dwStyle=WS_CHILD|WS_VISIBLE|WS_TABSTOP;
 char szClassName[]="Output";
 WNDCLASSEX wc;
 HWND hCtl;

 //Create Child Window Controls On Main Form
 Wea->hIns=((LPCREATESTRUCT)Wea->lParam)->hInstance;
 hCtl=CreateWindow("static","Choose Kind of Box",WS_CHILD|WS_VISIBLE,10,10,140,25,Wea->hWnd,(HMENU)-1,Wea->hIns,0);
 hCtl=CreateWindow("combobox","",dwStyle|CBS_DROPDOWNLIST|WS_VSCROLL,150,10,140,100,Wea->hWnd,(HMENU)IDC_COMBO_TYPE,Wea->hIns,0);
 for(unsigned int i=0; i<5; i++)
     SendMessage(hCtl,CB_INSERTSTRING,(WPARAM)-1,(LPARAM)szBuffer[i]);
 SendMessage(hCtl,CB_SETCURSEL,(WPARAM)0,0);  //|WS_TABSTOP
 hCtl=CreateWindow("static","Length of Box",WS_CHILD|WS_VISIBLE,10,53,125,25,Wea->hWnd,(HMENU)-1,Wea->hIns,0);
 hCtl=CreateWindowEx(WS_EX_CLIENTEDGE,"edit","",dwStyle,150,50,70,25,Wea->hWnd,(HMENU)IDC_EDIT_LENGTH,Wea->hIns,0);
 hCtl=CreateWindow("static","Width of Box",WS_CHILD|WS_VISIBLE,10,93,125,25,Wea->hWnd,(HMENU)-1,Wea->hIns,0);
 hCtl=CreateWindowEx(WS_EX_CLIENTEDGE,"edit","",dwStyle,150,90,70,25,Wea->hWnd,(HMENU)IDC_EDIT_WIDTH,Wea->hIns,0);
 hCtl=CreateWindow("static","Height of Box",WS_CHILD|WS_VISIBLE,10,133,125,25,Wea->hWnd,(HMENU)-1,Wea->hIns,0);
 hCtl=CreateWindowEx(WS_EX_CLIENTEDGE,"edit","",dwStyle,150,130,70,25,Wea->hWnd,(HMENU)IDC_EDIT_HEIGHT,Wea->hIns,0);
 hCtl=CreateWindow("static","Volume",WS_CHILD|WS_VISIBLE,10,183,50,25,Wea->hWnd,(HMENU)-1,Wea->hIns,0);
 hCtl=CreateWindowEx(WS_EX_CLIENTEDGE,"edit","",dwStyle,60,180,335,25,Wea->hWnd,(HMENU)IDC_EDIT_VOLUME,Wea->hIns,0);
 hCtl=CreateWindow("button","Calculate",dwStyle,245,65,120,30,Wea->hWnd,(HMENU)IDC_BUTTON_CALCULATE,Wea->hIns,0);
 hCtl=CreateWindow("button","Display",dwStyle,245,110,120,30,Wea->hWnd,(HMENU)IDC_BUTTON_DISPLAY,Wea->hIns,0);
 SetWindowText(Wea->hWnd,"Volume Of Your Box");
 SetFocus(GetDlgItem(Wea->hWnd,IDC_COMBO_TYPE));

 //Register Output Screen Class
 wc.lpszClassName=szClassName,                           wc.lpfnWndProc=fnOutputProc;
 wc.cbSize=sizeof (WNDCLASSEX),                          wc.style=CS_DBLCLKS;
 wc.hIcon=LoadIcon(NULL,IDI_APPLICATION),                wc.hInstance=Wea->hIns;
 wc.hIconSm=LoadIcon(NULL, IDI_APPLICATION),             wc.hCursor=LoadCursor(NULL,IDC_ARROW);
 wc.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH),   wc.cbWndExtra=4;
 wc.lpszMenuName=NULL,                                   wc.cbClsExtra=0;
 RegisterClassEx(&wc);

 return 0;
}


void btnCalculate_OnClick(lpWndEventArgs Wea)
{
 double dblLength,dblWidth,dblHeight,dblVolume;
 char szBuffer[64],szBoxType[16],szText[64];

 GetWindowText(GetDlgItem(Wea->hWnd,IDC_EDIT_LENGTH),szBuffer,16);
 dblLength=atof(szBuffer);
 GetWindowText(GetDlgItem(Wea->hWnd,IDC_EDIT_WIDTH),szBuffer,16);
 dblWidth=atof(szBuffer);
 GetWindowText(GetDlgItem(Wea->hWnd,IDC_EDIT_HEIGHT),szBuffer,16);
 dblHeight=atof(szBuffer);
 GetWindowText(GetDlgItem(Wea->hWnd,IDC_COMBO_TYPE),szBoxType,16);
 dblVolume=dblLength*dblWidth*dblHeight;
 sprintf(szBuffer,"%8.2f",dblVolume);
 strcpy(szText,"Your ");
 strcat(szText,szBoxType);
 strcat(szText," Has A Volume Of ");
 strcat(szText,szBuffer);
 SetWindowText(GetDlgItem(Wea->hWnd,IDC_EDIT_VOLUME),szText);
}


void btnDisplay_OnClick(lpWndEventArgs Wea)
{
 ProgramData ProDta;
 char szBuffer[64];
 HINSTANCE hIns;
 HWND hWnd;

 GetWindowText(GetDlgItem(Wea->hWnd,IDC_EDIT_LENGTH),szBuffer,16);
 ProDta.dblLength=atof(szBuffer);
 GetWindowText(GetDlgItem(Wea->hWnd,IDC_EDIT_WIDTH),szBuffer,16);
 ProDta.dblWidth=atof(szBuffer);
 GetWindowText(GetDlgItem(Wea->hWnd,IDC_EDIT_HEIGHT),szBuffer,16);
 ProDta.dblHeight=atof(szBuffer);
 GetWindowText(GetDlgItem(Wea->hWnd,IDC_COMBO_TYPE),ProDta.szBoxType,16);
 ProDta.dblVolume = ProDta.dblLength * ProDta.dblWidth * ProDta.dblHeight;
 hIns=GetModuleHandle(0);
 hWnd=CreateWindow("Output","Output Screen",WS_OVERLAPPEDWINDOW,650,300,350,200,0,0,hIns,&ProDta);
 ShowWindow(hWnd,SW_SHOWNORMAL);
}


long fnWndProc_OnCommand(lpWndEventArgs Wea)
{
 switch(LOWORD(Wea->wParam))
 {
    case IDC_BUTTON_CALCULATE:
         btnCalculate_OnClick(Wea);
         break;
    case IDC_BUTTON_DISPLAY:
         btnDisplay_OnClick(Wea);
         break;
 }

 return 0;
}


long fnWndProc_OnClose(lpWndEventArgs Wea)
{
 HWND hOutput;

 do //Search And Destroy Mission For Any Output Windows Hanging Around
 {
  hOutput=FindWindowEx(0,0,"Output","Output Screen");
  if(hOutput)
     SendMessage(hOutput,WM_CLOSE,0,0);
  else
     break;
 }while(TRUE);
 DestroyWindow(Wea->hWnd);
 PostQuitMessage(0);

 return 0;
}


void AttachEventHandlers(void)         //This procedure maps windows messages to the
{                                      //procedure which handles them.
 MainHandler[0].Code=WM_CREATE,       MainHandler[0].fnPtr=fnWndProc_OnCreate;
 MainHandler[1].Code=WM_COMMAND,      MainHandler[1].fnPtr=fnWndProc_OnCommand;
 MainHandler[2].Code=WM_CLOSE,        MainHandler[2].fnPtr=fnWndProc_OnClose;
 OutputHandler[0].Code=WM_CREATE,     OutputHandler[0].fnPtr=fnOutputProc_OnCreate;
 OutputHandler[1].Code=WM_PAINT,      OutputHandler[1].fnPtr=fnOutputProc_OnPaint;
 OutputHandler[2].Code=WM_CLOSE,      OutputHandler[2].fnPtr=fnOutputProc_OnClose;
}


long __stdcall fnWndProc(HWND hwnd, unsigned int msg, WPARAM wParam,LPARAM lParam)
{
 WndEventArgs Wea;                  //This procedure loops through the EVENTHANDER array
                                    //of structs to try to make a match with the msg parameter
 for(unsigned int i=0; i<3; i++)    //of the WndProc.  If a match is made the event handling
 {                                  //procedure is called through a function pointer -
     if(MainHandler[i].Code==msg)   //(EventHandler[i].fnPtr).  If no match is found the
     {                              //msg is passed onto DefWindowProc().
        Wea.hWnd=hwnd, Wea.lParam=lParam, Wea.wParam=wParam;
        return (*MainHandler[i].fnPtr)(&Wea);
     }
 }

 return (DefWindowProc(hwnd, msg, wParam, lParam));
}


int __stdcall WinMain(HINSTANCE hInstance, HINSTANCE hPrevIns, LPSTR lpszArgument, int iShow)
{
 char szClassName[]="Form3";
 WNDCLASSEX wc;
 MSG messages;
 HWND hWnd;

 AttachEventHandlers();
 wc.lpszClassName=szClassName;                wc.lpfnWndProc=fnWndProc;
 wc.cbSize=sizeof (WNDCLASSEX);               wc.style=CS_DBLCLKS;
 wc.hIcon=LoadIcon(NULL,IDI_APPLICATION);     wc.hInstance=hInstance;
 wc.hIconSm=LoadIcon(NULL, IDI_APPLICATION);  wc.hCursor=LoadCursor(NULL,IDC_ARROW);
 wc.hbrBackground=(HBRUSH)COLOR_BTNSHADOW;    wc.cbWndExtra=0;
 wc.lpszMenuName=NULL;                        wc.cbClsExtra=0;
 RegisterClassEx(&wc);
 hWnd=CreateWindowEx(0,szClassName,szClassName,WS_OVERLAPPEDWINDOW,100,400,410,250,HWND_DESKTOP,0,hInstance,0);
 ShowWindow(hWnd,iShow);
 while(GetMessage(&messages,NULL,0,0))
 {     //Is it not a Dialog Message?
    if(!IsDialogMessage(hWnd,&messages)) //Added this because it does special character code translations that
    {                                    //allows the use of the tab key to move focus among child window
       TranslateMessage(&messages);      //controls with the WS_TABSTOP style on the main Form.
       DispatchMessage(&messages);
    }
 }

 return messages.wParam;
}
