//Output.cpp
#include <windows.h>
#include <stdio.h>
#include "ProgEx40d.h"
#include "Output.h"
extern EVENTHANDLER  OutputHandler[3];


long fnOutputProc_OnCreate(lpWndEventArgs Wea)
{
 CREATESTRUCT *pCreateStruct;
 ProgramData* pProgramData;
 ProgramData* pMain;

 pCreateStruct=(CREATESTRUCT*)Wea->lParam;
 pMain=(ProgramData*)pCreateStruct->lpCreateParams;
 pProgramData=(ProgramData*)GlobalAlloc(GPTR,sizeof(ProgramData));
 if(pProgramData)
 {
    SetWindowLong(Wea->hWnd,0,(long)pProgramData);
    pProgramData->dblLength=pMain->dblLength;
    pProgramData->dblWidth=pMain->dblWidth;
    pProgramData->dblHeight=pMain->dblHeight;
    pProgramData->dblVolume=pMain->dblVolume;
    strcpy(pProgramData->szBoxType,pMain->szBoxType);
 }
 else           //If we can't allocate the memory there isn't much use
    return -1;  //continuing so -1 causes CreateWindow to fail.

 return 0;
}


long fnOutputProc_OnPaint(lpWndEventArgs Wea)
{
 char szBuffer[64],szNumber[16];
 ProgramData* pProgramData;
 HFONT hFont,hTmp;
 PAINTSTRUCT ps;
 HDC hDC;

 hDC=BeginPaint(Wea->hWnd,&ps);
 pProgramData=(ProgramData*)GetWindowLong(Wea->hWnd,0);
 hFont=CreateFont(20,0,0,0,FW_BOLD,0,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,PROOF_QUALITY,DEFAULT_PITCH,"Courier New");
 hTmp=(HFONT)SelectObject(hDC,hFont);
 strcpy(szBuffer,"Box Type    = "), strcat(szBuffer,pProgramData->szBoxType);
 TextOut(hDC,40,20,szBuffer,strlen(szBuffer));
 sprintf(szNumber,"%8.2f",pProgramData->dblLength);
 strcpy(szBuffer,"Length      = "), strcat(szBuffer,szNumber);
 TextOut(hDC,40,40,szBuffer,strlen(szBuffer));
 sprintf(szNumber,"%8.2f",pProgramData->dblWidth);
 strcpy(szBuffer,"Width       = "), strcat(szBuffer,szNumber);
 TextOut(hDC,40,60,szBuffer,strlen(szBuffer));
 sprintf(szNumber,"%8.2f",pProgramData->dblHeight);
 strcpy(szBuffer,"Height      = "), strcat(szBuffer,szNumber);
 TextOut(hDC,40,80,szBuffer,strlen(szBuffer));
 sprintf(szNumber,"%8.2f",pProgramData->dblVolume);
 strcpy(szBuffer,"Volume      = "), strcat(szBuffer,szNumber);
 TextOut(hDC,40,100,szBuffer,strlen(szBuffer));
 SelectObject(hDC,hTmp);
 DeleteObject(hFont);
 EndPaint(Wea->hWnd,&ps);

 return 0;
}


long fnOutputProc_OnClose(lpWndEventArgs Wea)
{
 ProgramData* pProgramData=NULL;

 pProgramData=(ProgramData*)GetWindowLong(Wea->hWnd,0);
 if(pProgramData)
    GlobalFree(pProgramData);
 DestroyWindow(Wea->hWnd);

 return 0;
}



long __stdcall fnOutputProc(HWND hwnd, unsigned int msg, WPARAM wParam,LPARAM lParam)
{
 WndEventArgs Wea;                  //This procedure loops through the EVENTHANDER array
                                    //of structs to try to make a match with the msg parameter
 for(unsigned int i=0; i<3; i++)    //of the WndProc.  If a match is made the event handling
 {                                  //procedure is called through a function pointer -
     if(OutputHandler[i].Code==msg) //(OutputHandler[i].fnPtr).  If no match is found the
     {                              //msg is passed onto DefWindowProc().
        Wea.hWnd=hwnd, Wea.lParam=lParam, Wea.wParam=wParam;
        return (*OutputHandler[i].fnPtr)(&Wea);
     }
 }

 return (DefWindowProc(hwnd, msg, wParam, lParam));
}
